
**********************
* Miscellany
**********************

> module Miscellany where
> import Basics 
> import Ratio

> nyi :: a
> nyi = error "This function is not yet implemented"

> listMax :: Ord a => [a] -> a
> listMax = foldl1 max

> listMin :: Ord a => [a] -> a
> listMin = foldl1 min

> scanAcc :: (a -> a) -> Int -> a -> [a]
> scanAcc fn count item = scanAccIter fn 0 count item where					      
>   scanAccIter fn count max item = if (count < max)
>                                   then fn item : scanAccIter fn (count + 1) max (fn item) 
>                                   else []

For a given list, calculate all possible unique combinations of elements in that list.  I am certain that the following algorithm is not the best way to do this.  Probably some matrix thing would work better.  Also, "combination" may not be the right word to use here...

> listCombinations :: [a] -> [(a,a)]
> listCombinations [] = []
> listCombinations (x:xs) = (combinations x xs) ++ listCombinations xs  

> combinations :: a -> [a] -> [(a,a)]
> combinations _    []    = []
> combinations item aList = take (length aList) (zip (repeat item) aList) 

> chunk :: Int -> [a] -> [[a]]
> chunk _    []    = []
> chunk size aList = ((take size aList):(chunk size (drop size aList)))

> fromInt :: Num a => Int -> a
> fromInt = fromInteger . toInteger

Turn a sequence into a set of pairs.

e.g.) zipSeq [1,2,3,4] --> [(1,2), (2,3), (3,4)]

> zipSeq :: [a] -> [(a,a)] 
> zipSeq [] = []
> zipSeq l@(x:xs) = zip l xs 

*******************
* Ratio Utilities
*******************

> fromIRatio :: (Integral a, Fractional b) => Ratio a -> b
> fromIRatio = fromRational . toRational

> durToRational :: Dur -> Rational
> durToRational = ratioIntToRational

> ratioIntToRational :: Ratio Int -> Rational
> ratioIntToRational d = (toInteger (numerator d)) % (toInteger (denominator d))

A function that finds the nearest integer beneath this ratio.

> iRatioFloor :: (Integral a) => Ratio a -> a
> iRatioFloor = floor.fromIRatio

> isWholeNum n = (fromIntegral (floor n)) == n



